# RDD Technical Reference

Guidelines and references for software development in RDD

To create main markdown document and compile to PDF, use

```bash
cat technical-reference-main.txt | while read LINE; do cat $LINE >> technical-reference.md ; done
pandoc --template=rdd.latex technical-reference.md -o technical-reference.pdf
```
or, for the use with docker

```bash
cat technical-reference-main.txt | while read LINE; do cat $LINE >> technical-reference.md ; done
docker run --rm pandoc/latex -v .:/data pandoc --template=rdd.latex technical-reference.md -o technical-reference.pdf
```

Inspired by the [EURISE Network Technical Reference](https://github.com/eurise-network/technical-reference).


## Sources and PDF

The sources and the PDF of this reference are available continuously with every release here: https://gitlab.gwdg.de/fe/technical-reference/-/releases


## Contributing

Commits have to be made following a certain convention that is defined by the
[Conventional Commit](https://www.conventionalcommits.org/en/v1.0.0/) standard.
This repo is configured to be used with [Commitizen](https://github.com/commitizen/cz-cli) for your convenience
and uses the [angular preset](https://github.com/conventional-changelog/conventional-changelog).

Install it with

```bash
npm install
```

You can now run a commit using commitizen with `git cz`.

To run commitizen on `git commit` rather than on `git cz`, update or create `.git/hooks/prepare-commit-msg` with the following code:

```bash
#!/bin/bash
exec < /dev/tty && node_modules/.bin/git-cz --hook || true
```

We have chosen the following two types of commits to be used for the work on the technical reference
that should reflect the extent of your contribution:

- `fix`: Small addition to or revision of the Technical Reference's Markdown files.
- `feat`: Medium addition to or revision of the Technical Reference's Markdown files.

These commit types trigger a `patch` or `minor` release when merged into the `master` branch.
To trigger a `major` release, please consult your fellow contributors and mark one of your commits with a `BREAKING CHANGE`.

The `master` branch is protected for direct commits, so please use feature branches and do merge them into `master`.
